//+------------------------------------------------------------------+
//|                                                  MultiTF_OOP.mq5 |
//|                                                   Sergey Gritcay |
//|                                               sergey1294@list.ru |
//+------------------------------------------------------------------+
#property copyright "Sergey Gritcay"
#property link      "sergey1294@list.ru"
#property version   "1.00"

#include <multitf.mqh>

CName *M1[];
int bar[];
int SymbolTotal;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   SymbolTotal=SymbolsTotal(false);
   ArrayResize(M1,SymbolTotal);
   ArrayResize(bar,SymbolTotal);

   for(int i=0;i<SymbolTotal;i++)
     {
      M1[i]=new CName(SymbolName(i,false),PERIOD_M1);
      Print("  = ",M1[i]);
     }
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   for(int i=0;i<SymbolTotal;i++)delete(M1[i]);
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   int posx = 10;
   int posy = 10;

   bool NB=NewBar();

   for(int i=0;i<SymbolTotal;i++)
     {
      string symbol=SymbolName(i,false);
      if(NB)bar[i]=Bars(symbol,PERIOD_M1);
      if(bar[i]<90)continue;

      M1[i].MultiTF();
      Lebel(symbol,symbol,posx,posy,NULL,8,clrYellow);
      Lebel("Signal_ind_01_"+symbol,arrow(M1[i].sig_01()),posx+60,posy,"Wingdings",8,Colorarrow(M1[i].sig_01()));

      posy+=12;
      if(i==29){posx+=300;posy=10;}
      if(i==59){posx+=300;posy=10;}

     }
//---
  }
//+------------------------------------------------------------------+
bool NewBar()
  {
   datetime iTime[1];
   static datetime lastbar=0;
   if(CopyTime(_Symbol,PERIOD_W1,0,1,iTime)<1)return(false);

   datetime curbar=iTime[0];
   if(lastbar!=curbar)
     {
      lastbar=curbar;
      return(true);
     }
   else return(false);
  }
//+------------------------------------------------------------------+
void Lebel(string name,string text,int x,int y,string fontname,int font,color colors)
  {
   ObjectCreate(0,name,OBJ_LABEL,0,0,0);
   ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
   ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
   ObjectSetString(0,name,OBJPROP_TEXT,text);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(0,name,OBJPROP_FONT,fontname);
   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,font);
   ObjectSetInteger(0,name,OBJPROP_COLOR,colors);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string arrow(ENUM_ORDER_TYPE s)
  {
   switch(s)
     {
      case WRONG_VALUE:     return(CharToString(251));
      case ORDER_TYPE_BUY:  return(CharToString(233));
      case ORDER_TYPE_SELL: return(CharToString(234));
     }
   return("");
  }
//+------------------------------------------------------------------+
color Colorarrow(ENUM_ORDER_TYPE s)
  {
   switch(s)
     {
      case WRONG_VALUE: return(clrMediumAquamarine);
      case ORDER_TYPE_BUY:  return(clrBlue);
      case ORDER_TYPE_SELL:  return(clrRed);
     }
   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
